//---------------------------------------------------------------------------------------
//  MKNibOutletConnectionType.m created by erik on Fri Apr 12 2002
//  @(#)$Id: MKNibOutletConnectionType.m,v 1.5 2002/09/02 20:20:29 erik Exp $
//
//  Copyright (c) 2002 by Mulle Kybernetik. All rights reserved.
//
//  Permission to use, copy, modify and distribute this software and its documentation
//  is hereby granted, provided that both the copyright notice and this permission
//  notice appear in all copies of the software, derivative works or modified versions,
//  and any portions thereof, and that both notices appear in supporting documentation,
//  and that credit is given to Mulle Kybernetik in all documents and publicity
//  pertaining to direct or indirect use of this code or its derivatives.
//
//  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF WHICH MAY HAVE
//  SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE USE OF THIS SOFTWARE IN ITS
//  "AS IS" CONDITION. THE COPYRIGHT HOLDER DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY
//  DAMAGES WHATSOEVER RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE
//  OR OF ANY DERIVATIVE WORK.
//---------------------------------------------------------------------------------------

#import "MKConnectionBrowserCell.h"
#import "MKNibOutletConnectionType.h"


//=======================================================================================
    @implementation MKNibOutletConnectionType
//=======================================================================================

static NSString *MKOutletsConnectionType = @"Outlets";


//---------------------------------------------------------------------------------------

- (NSString *)name
{
    return MKOutletsConnectionType;
}


//---------------------------------------------------------------------------------------

- (NSArray *)socketLabelsForObject:(id)anObject
{
    return [anObject outletLabelsForDocument:document];
}


- (NSArray *)preferredSocketLabelsForObject:(id)anObject destination:(id)otherObject
{
    NSMutableArray	*preferredLabelList;
    NSEnumerator	*labelEnum;
    NSString		*label, *message;
    
    preferredLabelList = [NSMutableArray array];
    labelEnum = [[self socketLabelsForObject:anObject] objectEnumerator];
    while((label = [labelEnum nextObject]) != nil)
        {
        if([document typesMatchForOutletNamed:label forSource:anObject destination:otherObject message:&message])
            [preferredLabelList addObject:label];
        }
    return preferredLabelList;
}


- (void)setupSocketBrowserCell:(MKConnectionBrowserCell *)cell
{
    [cell setConnected:([cell representedObject] != nil)];
    [cell setLeaf:YES];
}


//---------------------------------------------------------------------------------------

- (BOOL)canConnectSource:(id)sourceObject socketLabel:(NSString *)label destination:(id)destObject path:(NSString *)path message:(NSString **)messagePtr
{
    if([document typesMatchForOutletNamed:label forSource:sourceObject destination:destObject message:messagePtr])
        *messagePtr = nil;
    return (destObject != nil);
}


- (id <IBConnectors>)connectorForSource:(id)source socketLabel:(NSString *)label destination:(id)destObject path:(NSString *)path
{
    NSNibOutletConnector	*connector;
    
    connector = [[[NSNibOutletConnector alloc] init] autorelease];
    [connector setSource:source];
    [connector setDestination:destObject];
    [connector setLabel:label];
    
    return connector;
}


//=======================================================================================
    @end
//=======================================================================================



//=======================================================================================
    @implementation NSNibOutletConnector(MKConnectionType)
//=======================================================================================

- (NSString *)sourceLabelForDocument:(id <MKIBDocuments>)document
{
    return [self label];
}


- (NSString *)destinationLabelForDocument:(id <MKIBDocuments>)document
{
    return [[self destination] nibLabel:[document nameForObject:[self destination]]];
}


- (NSString *)destinationPath
{
    return nil;
}


- (NSString *)connectionTypeName
{
    return MKOutletsConnectionType;
}

//=======================================================================================
    @end
//=======================================================================================

