//---------------------------------------------------------------------------------------
//  MKPathNode.m created by erik on Tue Jul 30 2002
//  @(#)$Id: MKPathNode.m,v 1.1.1.1 2002/07/31 20:45:27 erik Exp $
//
//  Copyright (c) 2002 by Mulle Kybernetik. All rights reserved.
//
//  Permission to use, copy, modify and distribute this software and its documentation
//  is hereby granted, provided that both the copyright notice and this permission
//  notice appear in all copies of the software, derivative works or modified versions,
//  and any portions thereof, and that both notices appear in supporting documentation,
//  and that credit is given to Mulle Kybernetik in all documents and publicity
//  pertaining to direct or indirect use of this code or its derivatives.
//
//  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF WHICH MAY HAVE
//  SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE USE OF THIS SOFTWARE IN ITS
//  "AS IS" CONDITION. THE COPYRIGHT HOLDER DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY
//  DAMAGES WHATSOEVER RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE
//  OR OF ANY DERIVATIVE WORK.
//---------------------------------------------------------------------------------------

#import <Foundation/Foundation.h>
#import "MKPathNode.h"


//---------------------------------------------------------------------------------------
    @implementation MKPathNode
//---------------------------------------------------------------------------------------

- (void)dealloc
{
    [label release];
    [children release];
    [super dealloc];
}


- (void)setLabel:(id)aLabel
{
    [aLabel retain];
    [label release];
    label = aLabel;
}

- (NSString *)label
{
    return label;
}


- (void)setChildren:(NSArray *)someNodes
{
    [someNodes retain];
    [children release];
    children = someNodes;
}

- (NSArray *)children
{
    return children;
}


- (void)setParent:(MKPathNode *)aNode
{
    parent = aNode;
}

- (MKPathNode *)parent
{
    return parent;
}


- (NSString *)path
{
    NSMutableString	*path;
    
    if(label == nil)
        {
        path = nil;
        }
    else if((path = (NSMutableString *)[parent path]) == nil)
        {
        path = [NSMutableString stringWithString:label];
        }
    else
        {
        [path appendString:@"."];
        [path appendString:label];
        }
    return path;
}


//---------------------------------------------------------------------------------------
    @end
//---------------------------------------------------------------------------------------
